/*
 * Copyright 2024 Luca Fulchir <luca.fulchir@runesauth.com>
 *
 * Licensed under the Apache License, Version 2.0 with LLVM exception (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License and of the exception at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *     https://spdx.org/licenses/LLVM-exception.html
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

use crate::libt;
//use ::std::{boxed::Box, vec::Vec};

crate::libt::moduse! {
    one
        two
        three
}

///
/// This is a Package List
///
/// eventually all this will be replaced by macros
pub struct Pkgs1 {}

pub trait Pkgs1NewPkgs {
    fn one() -> One {
        One::new()
    }
    fn two() -> Two {
        Two::new()
    }
}
pub trait Pkgs1Pkgs: Pkgs1NewPkgs + libt::PkgList {}

impl Pkgs1NewPkgs for Pkgs1 {}
//impl<Pkgs1: Pkgs1NewPkgs + libt::PkgList> Pkgs1Pkgs for Pkgs1 {}
impl<Pkgs1: Pkgs1NewPkgs + libt::PkgList> Pkgs1Pkgs for Pkgs1 {}

///
/// This is a Package List that extends and changes Pkgs1
///
/// eventually all this will be replaced by macros
pub struct Pkgs2 {}

pub trait Pkgs2NewPkgs {
    fn two() -> Two {
        let mut t = Two::new();
        t.my_attr = 42;
        t
    }
    fn three() -> Three {
        Three::new()
    }
}

pub trait Pkgs2Pkgs: Pkgs2NewPkgs + Pkgs1Pkgs {}
impl<Pkgs2: Pkgs2NewPkgs + Pkgs1Pkgs> Pkgs2Pkgs for Pkgs2 {}
impl Pkgs2NewPkgs for Pkgs2 {}
impl Pkgs1NewPkgs for Pkgs2 {}
